var moment = require('moment'); 

function checksum(s)
{
    for(var r=0,i=0;i<s.length;i++)r=(r<<5)-r+s.charCodeAt(i),r&=r;return r;
}

// 'abc' -> return abc
function removeQuote(inStr)
{
    return inStr.slice(1, -1); 
}

// ($this, 'COL_NAME') -> returns 'COL_NAME'
// ($COL_NAME2, 'COL_NAME') -> returns 'COL_NAME2'
function getColName(variable, colName)
{
    var ret;
    if( '$this' === variable.trim())
        ret = colName;
    else 
        ret = variable.substr(1, variable.length);

    return ret;
}

function isVariable(variable)
{
    return ( variable[0] === '$') ?  true :  false; 
}


function format_dt(src, param)
{
    var parameters = param.split(',');
    var ret = src; 
    // simple format
    if( parameters.length == 1 ) {
        var p = removeQuote(param);
        ret = moment(src, p).format(p);
    }
    else if (parameters.length == 5) {
        var fmt = removeQuote(parameters[0].trim()); 
        var unitOfTime = removeQuote(parameters[1].trim());;
        var addOrsub = removeQuote(parameters[2].trim());
        var adjAmount = removeQuote(parameters[3].trim());
        var startOrend = removeQuote(parameters[4].trim()); 

        var curMoment = moment(src); 
        var adjMoment; 
        var roundedMoment = adjMoment; 
        // console.log( 'fmt = ' + fmt + ' unitoftime = ' + unitOfTime + ' addorsub = ' + addOrsub + ' adjAmount = ' + adjAmount + ' startorend = ' + startOrend);

        if(addOrsub === 'Add') {
            adjMoment = moment(src).add(Number(adjAmount), unitOfTime); 
        } 
        else if (addOrsub === 'Subtract') {
            adjMoment = moment(src).subtract(unitOfTime, Number(adjAmount)); 
        }
        else 
            adjMoment = moment(src);
      

        // moment has two format for unit of time
        // so unfortuntely this is to workaround that
        // just remove the last char 's' is the new format (e.g. months -> month )
        var newUnitOftime = unitOfTime.slice(0, -1); 
        if(startOrend === 'startOf') {
            roundedMoment = moment(adjMoment).startOf(newUnitOftime);
        }
        else if (startOrend === 'endOf' ) {
            roundedMoment = moment(adjMoment).endOf(newUnitOftime);
        }
        
        ret = moment(roundedMoment).format(fmt);
        //console.log(curMoment.format(fmt) + '..' + adjMoment.format(fmt) + '..' + roundedMoment.format(fmt) + '..' + ret);

    }

    return ret; 
}

function format_string(src, cols, param)
{
    //console.log("src: " + JSON.stringify(src));
    //console.log("cols: " + cols);
    //console.log("param: " + param);
    var strVal = '';
    for (var i = 0; i < param.length; i++) {
        var p = param[i];
        //console.log("p: " + p);
        if(isVariable(p)) {
            var colName = getColName(p, colName);
            //console.log("col name: " + colName);
            strVal += src[colName];
        }
        else {
            strVal += p.includes('\'') || p.includes('\"') ? removeQuote(p) : p;
        }
    }

    return strVal;
}

function sum(src, cols, param)
{
    var sum  = 0;
    var val; 

     for (var i = 0; i < param.length; i++) {
        var p = param[i].trim();
        if(isVariable(p)) {
            var colName = getColName(p, colName);
            var valStr = src[colName];
            if( !isNaN(valStr))
                sum += Number(valStr); 
        }
        else {
            sum += Number(p);
        }
    }

    return sum.toString(); 
}


function hash(src, cols, param)
{
    // single column
    var colName = cols[0];
    var val = src[colName];

    for(var r = 0, i = 0; i < val.length;i++) 
        r = (r<<5)-r+val.charCodeAt(i),r&=r;
    return r;
}

function if_binary(src, cols, params)
{
    console.log('s' + src);
    console.log('c' + cols);
    console.log(params);

    // ONLY SUPPORT 1 COLUMN RIGHT NOW
    var colName = cols[0];
    //console.log("cols: " + cols)
    //console.log("src: " + JSON.stringify(src));
    //console.log("params: " + JSON.stringify(params));

    var testOp = params.testOperator; 
    var parsedColName;


    var testL;
    var testR;
    var consequentR;
    var alternateR;

    // consequentL and alternateL are always "$self"

    // testL
    parsedColName = getColName(params.testLeft, colName); 
    testL = src[parsedColName];

    // testR
    if(true === isVariable(params.testRight) ) {
        parsedColName = getColName(params.testRight, colName);
        testR = src[parsedColName];
    }
    else
        testR = params.testRight;
    
    // consequentR 
    if(true === isVariable(params.consequentRight) ) {
        parsedColName = getColName(params.consequentRight, colName);
        consequentR = src[parsedColName];
    }
    else{
        if (params.consequentRight.name === "format_string"){
            consequentR = format_string(src, null, params.consequentRight.params);
        } else if (params.consequentRight.name === "format_dt"){
            console.log("src in if_binary: " + JSON.stringify(src));
            console.log("params in if_binary: " + JSON.stringify(params));
            consequentR = format_dt(src, params.consequentRight.params);
        } else
            consequentR = params.consequentRight;
    }
        

    // alternateR 
    if(true === isVariable(params.alternateRight) ) {
        parsedColName = getColName(params.alternateRight, colName);
        alternateR = src[parsedColName];
    }
    else
        alternateR = params.alternateRight;
    
    //console.log("testL: " + testL + " testR: " + testR + " consequentR: " + consequentR + " alternateR: " + alternateR + " testOp: " + testOp);

    var returnVal = undefined; 
    switch(testOp) {
        case '>':
            returnVal = ( testL > testR) ? consequentR : alternateR; 
            break;
        case '>=':
            returnVal = ( testL >= testR) ? consequentR : alternateR; 
            break;
        case '<':
            returnVal = ( testL < testR) ? consequentR : alternateR; 
            break;
        case '<=':
            returnVal = ( testL <= testR) ? consequentR : alternateR; 
            break;
        case '==':
            returnVal = ( testL == testR) ? consequentR : alternateR; 
            break;
        case '!=':
            returnVal = ( testL != testR) ? consequentR : alternateR; 
            break;
        default:
            break;
    }
    
    // force convert return type to string
    if (returnVal !== undefined) 
        returnVal = ''+ returnVal;

    return returnVal;
}


function switch_case(src, cols, params)
{   
    var colName = cols[0];

    // testL
    var discriminantCol = getColName(params.discriminant, colName)
    var testL = src[discriminantCol];

    // going through all the cases
    for (var i = 0; i <params.cases.length; i++) {
        var paramCase = params.cases[i];

        var testRColName;
        // testR
        if( paramCase.test === '$DEFAULT')
            testR = undefined; 
        else if( true === isVariable(paramCase.test)) {
            var testRColName = getColName(paramCase.test, colName);
            testR = src[testRColName];
        }
        else    
            testR = paramCase.test;

        // consequentL
        var consequentL;
        if( true === isVariable(paramCase.consequentLeft)) {
            var conLColName = getColName(paramCase.consequentLeft, colName);
            consequentL = src[conLColName];        
        }
        else    
            consequentL = paramCase.consequentLeft;     

        // consequentR
        var consequentR;
        if( true === isVariable(paramCase.consequentRight)) {
            var conRColName = getColName(paramCase.consequentRight, colName);
            consequentR = src[conRColName];
        }
        else    
            consequentR = paramCase.consequentRight;     
        

        // check this case, if match (or this is default switch) break
        if( testL === testR || testR === undefined)  {
            return consequentR; 
        }
    }

    // should never be here
    return undefined; 

}


// compare two dates. E.g. if 20170301 is after 20170228, return true.
function compare_dt(src, params) {
    // console.log("in compare_dt src: " + JSON.stringify(src));
    // console.log("in compare_dt params: " + params);
    var obj = (typeof src === 'string') ? JSON.parse(src) : src;
    var parameters = (typeof params === 'string') ? JSON.parse(params) : params;
    var paramLeft = parameters[0];
    var paramRight = parameters[1];

    var left = (isVariable(paramLeft)) ? obj[paramLeft.substring(1)] : paramLeft;
    var right = (isVariable(paramRight.substring(1))) ? obj[paramRight] : paramRight;
        
    return moment(left, 'YYYYMMDD').isAfter(moment(right, 'YYYYMMDD'));
}

// format a date from YYYYMMDD to given format, e.g. M/D/YYYY
function format_dt1(src, param) {
    var obj = (typeof src === 'string') ? JSON.parse(src) : src;
    var parameters = (typeof param === 'string') ? JSON.parse(param) : param;
    var format = parameters[0];
    var val = (isVariable(parameters[1])) ? obj[parameters[1].substring(1)] : parameters[1];

    return moment(val, 'YYYYMMDD').format(format);
}

// format FDF invoice to 'P *** *** ***-*'
function format_invoice(src, param) {
    var val = (isVariable(param[0])) ? src[param[0].substring(1)] : param[0];
            
    return val.substring(0, 1) + " " + val.substring(1, 4) + " " + val.substring(4, 7) + " " + val.substring(7);
}

// format the amount from string such like -00000000000.12 to float -0.12
function format_amount (src, param) {
    var val = (isVariable(param[0])) ? src[param[0].substring(1)] : param[0];
    
    return parseFloat(val).toFixed(2);
}

// evaluate an if statement. the test condition is a function.
function if_function(src, params) {
    // console.log("in if_function src: " + JSON.stringify(src));
    // console.log("in if_function params: " + JSON.stringify(params));
    var testFun = params.test;
    var testFunName = testFun.name;
    var testFunParams = testFun.params;
    var testResult;
    // consequentL and alternateL are always "$self"
    var consequentR;
    var alternateR;

    var funStr = testFunName + "('" + JSON.stringify(src) + "','" + JSON.stringify(testFunParams) + "')";
    testResult = eval(funStr);
    
    funStr = params.consequentRight.name + "('" + JSON.stringify(src) + "','" + JSON.stringify(params.consequentRight.params) + "')";
    consequentR = eval(funStr);
    
    funStr = params.alternateRight.name + "('" + JSON.stringify(src) + "','" + JSON.stringify(params.alternateRight.params) + "')";
    alternateR = eval(funStr);

    return testResult ? consequentR : alternateR;
}

// generate an update statement for tier mapping in Telstra fdf
function getUpdateStmntForTierMapping(src, params) {
    // console.log("in updateTier src: " + JSON.stringify(src));
    // console.log("in updateTier params: " + params);
    const mappingFields = src.mapping_fields;
    const tierObj = src.tierObj;
    const src_table = isVariable(params[0]) ? src.src_table : null;
    const func = src.func;
    
    let setPart = [];
    for (let i = 0; i < mappingFields.length; i++) {
        const field = mappingFields[i];
        setPart.push(`${field.column} = '${tierObj[field.valRef]}'`);
    }
    const updateStatement = `update ${src_table} set ${setPart.join(',')}`;
    // console.log("update statement: " + updateStatement);
    return updateStatement;
}

function select_record(src, params) {
    const fieldValue = params[0];
    const fieldRule = params[1];
    const fieldVariable = isVariable(params[2]) ? params[2].substring(1) : params[2];
    
    let result = false;
    if (fieldRule === "=") {
        if (src[fieldVariable] === fieldValue)
            result = true;
    }
    
    return result;
}


module.exports = {
    format_dt,
    format_string,
    sum,
    if_binary,
    switch_case,
    compare_dt,
    format_dt1,
    format_invoice,
    format_amount,
    if_function,
    getUpdateStmntForTierMapping,
    select_record
}; 
